#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <locale.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>

int main(void)
{
    unsigned int frame = 0;
    int y = 1;

    // ʂ̏
    clrscr();

    // P[mF
    {
        char *p = setlocale(LC_ALL, NULL);

        if (p == NULL) {
            p = strerror(errno);
        }
        gotoxy(1, y++); cprintf("locale: %s", p);
    }

    // P[ݒ
    {
        char *p = setlocale(LC_ALL, "JPN");

        if (p == NULL) {
            p = strerror(errno);
        }
        gotoxy(1, y++); cprintf("locale: %s", p);
    }

    y++;

    // 
    {
        char s[] = "ABCDEFGHIJ";
        size_t l = strlen(s);

        gotoxy(1, y++); cprintf("%s strlen()=%u", s, l);
    }

    y++;

    // r
    {
        char s1[] = "ABCDEF";
        char s2[] = "ABC";
        char s3[] = "ABCDEF";
        int c1 = strncmp(s1, s2, sizeof(s1));
        int c2 = strncmp(s1, s3, sizeof(s1));

        gotoxy(1, y++); cprintf("strncmp(%s,%s,%d)=%d", s1, s2, sizeof(s1), c1);
        gotoxy(1, y++); cprintf("strncmp(%s,%s,%d)=%d", s1, s3, sizeof(s1), c2);
    }

    y++;

    // A
    {
        char s1[10] = "ABC";
        char s2[]   = "DEF";
        char *p;

        gotoxy(1, y++); cprintf("strncat(%s,%s,%d)=>", s1, s2, sizeof(s1));
        p = strncat(s1, s2, sizeof(s1));
        cprintf("%s", p);
    }

    y++;

    // 񕡎
    {
        char s1[10] = "ABCD";
        char s2[]   = "EFG";
        char *p;

        gotoxy(1, y++); cprintf("strncpy(%s,%s,%d)=>", s1, s2, sizeof(s1));
        p = strncpy(s1, s2, sizeof(s1));
        cprintf("%s", p);
    }

    y++;

    // 
    {
        char s[] = "ABCDEF";
        char c1 = 'E';
        char c2 = 'B';
        char *p;

        gotoxy(1, y++); cprintf("strchr(%s,%c)=>", s, c1);
        p = strchr(s, c1);
        cprintf("%s", p);

        gotoxy(1, y++); cprintf("strrchr(%s,%c)=>", s, c2);
        p = strrchr(s, c2);
        cprintf("%s", p);
    }

    y++;

    // 񌟍
    {
        char s1[] = "ABCDEF";
        char s2[] = "DE";
        char *p;

        gotoxy(1, y++); cprintf("strstr(%s,%s)=>", s1, s2);
        p = strstr(s1, s2);
        cprintf("%s", p);
    }
    {
        char s1[] = "ABCABCDE";
        char s2[] = "ABC";
        char s3[] = "DE";
        size_t len;

        gotoxy(1, y++); cprintf("strspn(%s,%s)=>", s1, s2);
        len = strspn(s1, s2);
        cprintf("%u", len);

        gotoxy(1, y++); cprintf("strcspn(%s,%s)=>", s1, s3);
        len = strcspn(s1, s3);
        cprintf("%u", len);
    }


    y++;

    // 񕪉
    {
        char s1[] = "val=ABC|DE|FG";
        char s2[] = "=";
        char s3[] = "|";
        char *p;
        int i;

        gotoxy(1, y++); cprintf("strtok(%s,%s)=>", s1, s2);
        p = strtok(s1, s2);
        cprintf("%s", p);

        for (i = 0; ; ++i) {
            p = strtok(NULL, s3);
            if (p == NULL) break;
            gotoxy(1, y++); cprintf("%d: strtok(NULL,%s)=>%s", i, s3, p);
        }
    }

    y++;

    // ϊ
    {
        char s[12] = {'\0'};
        int v = 0xa5;
        int r = 2;
        char *p;

        gotoxy(1, y++); cprintf("itoa(%d,%s,%d)=>", v, s, r);
        p = itoa(v, s, r);
        cprintf("%s", p);
    }

    y++;

    // 
    {
        char s[30];
        int c = 'C';
        int len;

        len = snprintf(s, sizeof(s), "'%c' Is alpha=%d, lower=%d", c, isalpha(c), islower(c));
        gotoxy(1, y++); cprintf("%s (%d)", s, len);
    }

    // I点Ȃ߂̖[v
    while(1) {
        gotoxy(0, 0);
        cprintf("%8d", frame++);
    }

    return 0;
}
